package com.zhongzheng.common.utils;

import cn.hutool.http.HttpStatus;
import com.zhongzheng.common.core.domain.model.TopLoginUser;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import com.zhongzheng.common.core.domain.model.LoginUser;
import com.zhongzheng.common.exception.CustomException;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

/**
 * 安全服务工具类
 *
 * @author zhongzheng
 */
@Component
public class SecurityUtils
{

    @Value("${mybatis-plus.tenant.enabled-tenant:true}")
    public static boolean EnabledTenant;

    @Value("${mybatis-plus.tenant.enabled-tenant:true}")
    private boolean enabledTenant;

    @PostConstruct
    public void getEnvironment(){
        EnabledTenant = this.enabledTenant;
    }
    /**
     * 获取用户账户
     **/
    public static String getUsername()
    {
        try
        {
            if(EnabledTenant){
                return getLoginUser().getUsername();
            }else{
                return getTopLoginUser().getUsername();
            }

        }
        catch (Exception e)
        {
            throw new CustomException("获取用户账户异常", HttpStatus.HTTP_UNAUTHORIZED);
        }
    }

    /**
     * 获取用户
     **/
    public static LoginUser getLoginUser()
    {
        try
        {
            return (LoginUser) getAuthentication().getPrincipal();
        }
        catch (Exception e)
        {
            throw new CustomException("获取用户信息异常", HttpStatus.HTTP_UNAUTHORIZED);
        }
    }

    public static TopLoginUser getTopLoginUser()
    {
        try
        {
            return (TopLoginUser) getAuthentication().getPrincipal();
        }
        catch (Exception e)
        {
            throw new CustomException("获取用户信息异常", HttpStatus.HTTP_UNAUTHORIZED);
        }
    }

    /**
     * 获取Authentication
     */
    public static Authentication getAuthentication()
    {
        return SecurityContextHolder.getContext().getAuthentication();
    }

    /**
     * 生成BCryptPasswordEncoder密码
     *
     * @param password 密码
     * @return 加密字符串
     */
    public static String encryptPassword(String password)
    {
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        return passwordEncoder.encode(password);
    }

    /**
     * 判断密码是否相同
     *
     * @param rawPassword 真实密码
     * @param encodedPassword 加密后字符
     * @return 结果
     */
    public static boolean matchesPassword(String rawPassword, String encodedPassword)
    {
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        return passwordEncoder.matches(rawPassword, encodedPassword);
    }

    /**
     * 是否为管理员
     *
     * @param userId 用户ID
     * @return 结果
     */
    public static boolean isAdmin(Long userId)
    {
        return userId != null && 1L == userId;
    }
}
